import json
import os
import urllib
import http.client
import urllib.parse
import signal
import sys
import time
import datetime
import socket
from pathlib import Path
from http.server import HTTPServer, BaseHTTPRequestHandler
import json
import threading

# 127.0.0.1:31555/extension/invoke
class PostHandler(BaseHTTPRequestHandler):
    def do_POST(self):
        if self.path == "/extension/invoke":
            curTime = datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')
            content_len = int(self.headers.get("content-length"))
            post_body = self.rfile.read(content_len)
            tmpdata = post_body.decode()
            data = json.loads(tmpdata)
            traceid = data["traceId"]
            urn = data["invokedFunctionUrn"]
            print(f"{curTime} {traceid} current extension request, urn {urn} ", flush=True)
            self.send_response(200)
            data = "This is a python http function"
            self.send_header('Content-type', 'application/json')
            self.send_header('isBase64Encoded', 'false')
            self.end_headers()
            self.wfile.write(json.dumps(data).encode())

# global variables
# extension name has to match the file's parent directory name)
host = ('localhost', 8011)
name = "extensionDemo.sh"
addr = "127.0.0.1:8011"

# boiler plate code
def handle_signal(signal, frame):
    # if needed pass this signal down to child processes
    print(f"Extension Received signal={signal}. Exiting.", flush=True)
    sys.exit(0)

def register_extension():
    print(f"Extension Registering...", flush=True)
    headers = {
        'Content-type': 'application/json',
        'FunctionGraph-Extension-Name': name,
        'FunctionGraph-Extension-Address': addr
    }
    payload = {}
    json_data = json.dumps(payload)
    url1 = os.getenv("EXTENSION_API_ADDR")
    str = url1.split(':')
    address = str[0]
    port = str[1]
    url2=f"/extension/register"
    con = http.client.HTTPConnection(address, port)
    print(f"extension register successfully, EXTENSION_API_ADDR: {url1}", flush=True)
    con.request("POST", url2, json_data, headers)
    resu = con.getresponse()

def main():
    print(f"start extension", flush=True)
    # handle signals
    signal.signal(signal.SIGINT, handle_signal)
    signal.signal(signal.SIGTERM, handle_signal)
    server = HTTPServer(host, PostHandler)
    server_thread = threading.Thread(target=server.serve_forever)
    # Exit the server thread when the main thread terminates
    server_thread.daemon = True
    server_thread.start()
    # execute extensions logic
    register_extension()
    while True:
        time.sleep(1)

if __name__ == "__main__":
    main()
